document.getElementsByName("bg_radio").forEach(e => e.addEventListener("change", readBGColor));
eByID("volume_range").addEventListener("input", readSEVolume);
eByID("roll_button").addEventListener("click", startRoll);
eByID("t_textarea").addEventListener("input", initialize);
eByID("b_textarea").addEventListener("input", initialize);
eByID("check_bottom_roll").addEventListener("click", initialize);
window.addEventListener( 'resize', initialize, false );

var l_color = "#444444";
var l_color_f = "#ff0000" ;
var thickness = 3;
var n_steps = 10;
var margin_t = 40;
var margin_b = margin_t * 1.5;
var max_persons = 32;

const url_dir = "";

var se0 = new Audio(url_dir + "sounds/pi.mp3");
var ses = [new Audio(url_dir + "sounds/pu.mp3"),
new Audio(url_dir + "sounds/pu.mp3"),
new Audio(url_dir + "sounds/pu.mp3"),
];
var a_i = 0;
var volume = 0;
var verticals_follow = [];
var horizons_follow = [];

var entries_t = [];
var entries_b = [];
var all_horizons = [];

var onmouse_index = -1;
var onmouse_top = true;

window.onload = () => {
  eByID('t_textarea').value =
    '山田\n佐藤\n加藤\n高橋\n鈴木1\n鈴木2\n鈴木3\n鈴木4';
  eByID('b_textarea').value =
    'Aチーム\nAチーム\nAチーム\nBチーム\nBチーム\nBチーム\n審判';

  deleteAllHorizons();

  initialize();
};

function initialize() {
  readTextarea();
  readBGColor();
  readSEVolume();

  drawEntries(true);
  drawEntries(false);

  drawAmida();
}

function readTextarea() {
  var n_entries_last = entries_t.length;

  entries_t = eByID("t_textarea").value.split('\n');
  entries_b = eByID("b_textarea").value.split('\n');
  while (entries_t.length < 2) { entries_t.push(""); }
  while (entries_b.length < 2) { entries_b.push(""); }
  while (entries_t.length > max_persons) { entries_t.pop(); }
  while (entries_b.length > max_persons) { entries_b.pop(); }

  var n_t = entries_t.length;
  var n_b = entries_b.length;
  for (var i = 0; i < n_t - n_b; i++) { entries_b.push(""); }
  for (var i = 0; i < n_b - n_t; i++) { entries_t.push(""); }

  var n_entries = entries_t.length;
  if (n_entries_last != n_entries) deleteAllHorizons();
}

function readSEVolume() {
  var v = eByID("volume_range").value;
  se0.volume = v * 0.01;
  ses.forEach(se => se.volume = v * 0.01);
}

function readBGColor() {
  var es_radio = document.getElementsByName("bg_radio");
  if (es_radio[0].checked) {
    eByID("bg").style.background = "#00ff00";
  } else if (es_radio[1].checked) {
    eByID("bg").style.background = "#ffffff";
  } else {
    eByID("bg").style.background = "#0000ff";
  }
}

function playSE(rolling) {
  if (rolling) {
    ses[a_i % 3].play();
    a_i++;
  } else {
    se0.play();
  }
}

function drawEntries(top) {
  var entries = top ? entries_t : entries_b;
  var id = top ? "names_t" : "names_b";

  // clear
  var e_names = eByID(id);
  while (e_names.firstChild) {
    e_names.removeChild(e_names.firstChild);
  }

  // recreate
  for (var i = 0; i < entries.length; i++) {
    var e_div = document.createElement("div");
    e_names.appendChild(e_div);
    e_div.setAttribute("class", "entry_div");

    var e_p = document.createElement("p");
    e_div.appendChild(e_p);
    e_p.setAttribute("class", "entry_p");
    id_str = id + i;
    e_p.setAttribute("id", id_str);
    e_p.textContent = (entries[i] == "") ? "　" : entries[i];
    var w_t = eByID("amida_table").clientWidth;
    e_p.style.width = w_t / entries.length - 20 + "px";

    e_p.addEventListener("mouseover", { index: i, top: top, handleEvent: updateOnMouseIndex });
    e_p.addEventListener("mouseout", { index: -1, top: top, handleEvent: updateOnMouseIndex });

    if (e_div.clientWidth < 20) e_p.style.fontSize = "0.6rem";
  }

}

function updateOnMouseIndex() {
  onmouse_index = this.index; 
  onmouse_top = this.top;
  drawAmida();
}

function drawAmida() {
  follow();

  var c = eByID("lines");
  var ctx = c.getContext("2d");
  ctx.clearRect(0, 0, c.width, c.height);

  c.width = calcAmidaWidth();

  var n_entries = entries_t.length;
  var uw = (c.width - thickness) / (n_entries - 1);
  var uh = (c.height - margin_t - margin_b - thickness) / (n_steps - 1);

  // vertical
  for (var e = 0; e < n_entries; e++) {
    var x = e * uw;
    for (var s = 0; s < n_steps; s++) {
      var y = s * uh + margin_t;

      ctx.fillStyle = (verticals_follow[s + 1] == e) ? l_color_f : l_color;
      ctx.fillRect(x, y, thickness, uh + 1);
    }

    // margin top
    ctx.fillStyle = (verticals_follow[0] == e) ? l_color_f : l_color;
    ctx.fillRect(x, 0, thickness, margin_t);
    // margin bottom
    ctx.fillStyle = (verticals_follow[n_steps] == e) ?  l_color_f : l_color;
    ctx.fillRect(x, c.height - margin_b, thickness, margin_b);
  }

  // horizontal
  for (var s = 0; s < n_steps; s++) {
    for (var e = 0; e < n_entries - 1; e++) {
      if (!existHorizon(s, e)) continue;

      x = e * uw;
      y = s * uh + margin_t;

      ctx.fillStyle = (horizons_follow[s] == e) ? l_color_f : l_color;
      ctx.fillRect(x, y, uw + 1, thickness);
    }
  }
}

function calcAmidaWidth() {
  var e_l = eByID("names_t0");
  var lx = e_l.getBoundingClientRect().left + e_l.clientWidth / 2;
  var e_r = eByID("names_t" + (entries_t.length - 1));
  var rx = e_r.getBoundingClientRect().left + e_r.clientWidth / 2;

  return rx - lx + thickness;
}


function follow() {
  verticals_follow = [];
  horizons_follow = [];

  if (onmouse_index < 0) return;

  var p = onmouse_top ? onmouse_index : backflow(onmouse_index);

  for (var s = 0; s < n_steps; s++ ){
    verticals_follow.push(p);
    ps = all_horizons[s];
    if (ps.indexOf(p) != -1) { // to right 
      horizons_follow.push(p);
      p++;
    } else if (ps.indexOf(p - 1) != -1) { // to left
      horizons_follow.push(p - 1);
      p--;
    } else {
      horizons_follow.push(-1);
    }
  }
  verticals_follow.push(p);
}


function backflow(idx) {
  var p = idx;
  for (var s = n_steps - 1; s >= 0 ; s-- ){
    ps = all_horizons[s];
    if (ps.indexOf(p) != -1) { // to right 
      p++;
    } else if (ps.indexOf(p - 1) != -1) { // to left
      p--;
    } else {
    }
  }
  return p;
}

function deleteAllHorizons() {
  all_horizons = [];
  for (var s = 0; s < n_steps; s++) { all_horizons.push([]) };
}


function existHorizon(s, e) {
  if (all_horizons.length <= s) return false;
  return (all_horizons[s].indexOf(e) != -1);
}

function startRoll() {
  initialize();
  filterLines(true);

  var t = 0;

  function roll() {

    setElementsDisabled(true);

    if (t <= 59) {
      if (t >= 22 && t % 4 != 0) { }
      else if (t >= 30 && t % 6 != 0) { }
      else {
        rollAmida();
        rollBTextarea();
        drawAmida();
        if (t % 2 == 0) playSE(true);
      }
    }
    else {
      rollAmida();
      rollBTextarea();
      drawAmida();
      playSE(false);

      filterLines(false);
      setElementsDisabled(false);

      clearInterval(timer);
    }

    t++;
  }

  var timer = setInterval(roll, 50);
}


function rollAmida() {
  var n_entries = entries_t.length;

  var unused_spaces = [];
  for (var e = 0; e < n_entries - 1; e++) { unused_spaces.push(e) }

  all_horizons = [];
  for (var s = 0; s < n_steps; s++) {
    var horizons = [];
    var candicates = [];
    if (unused_spaces.length >= 1) {
      candicates = unused_spaces;
    } else {
      for (var e = 0; e < n_entries - 1; e++) { candicates.push(e); }
    }

    while (candicates.length > 0) {
      var k = candicates[ randomInt(candicates.length) ];

      candicates = candicates.filter(n => Math.abs(n - k) >= 2);

      if (horizons.length > 0 && unused_spaces.length == 0) {
        if (randomInt(4) == 0)  continue;
      }
      if (n_entries <= 3 && randomInt(4) == 0) continue;

      horizons.push(k);
      unused_spaces = unused_spaces.filter(n => n !== k);
    }

    all_horizons.push(horizons);
  }
}


function rollBTextarea() {
  if (!eByID("check_bottom_roll").checked) return;

  var ts = Array.from(entries_b);
  entries_b = [];
  while (ts.length >= 1) {
    var r = randomInt(ts.length);
    ts0 = ts.splice(r,1);
    entries_b.push(ts0);
  }

  drawEntries(false);
}


function setElementsDisabled(b) {
  eByID("check_bottom_roll").disabled = b;
  eByID("t_textarea").disabled = b;
  eByID("b_textarea").disabled = b;
  eByID("roll_button").disabled = b;
}

function filterLines(rolling) {
  var new_class = rolling ? "lines gray" : "lines";
  eByID("lines").setAttribute("class", new_class);
}

function randomInt(max) {
  return Math.floor(Math.random() * max);
}
function eByID(str) {
  return document.getElementById(str);
}


